.proc fade_pal

lda fadestate
cmp #$02
beq fadeout
cmp #$01
beq fadein
brk ; if this brk happens is an error it should never go here
rts 

fade_in_values:
.word paldim3low, paldim3, paldim2low, paldim2, paldim1low, paldim1, fullpallow, fullpal

fade_out_values:
.word fullpallow, paldim1, paldim1low, paldim2, paldim2low, paldim3, paldim3low, fadeoutdone

out:
rts

fadein:
lda gametimerlow	; fade in relies on gametimerlow to start at 00! make sure to set it (once!) before calling this
cmp #$10			; if you want the palette to be fully loaded without a fade in, set gametimerlow to #$10 or higher
bcs out

and #%11111110    	; remove the last bit, so it goes 0 2 4 6 etc
tay
lda fade_in_values,y
sta temp_ptr
lda fade_in_values+1,y
sta temp_ptr+1
ldy #$00
jmp (temp_ptr)
jmp out

fadeout:
lda gametimerlow	; if you want fadeout to happen instantly just set gametimerlow to #$b2 (once!) before calling this
cmp #$b2
bcc out

sec
sbc #$b2
and #%11111110    	; remove the last bit, so it goes 0 2 4 6 etc
tay
lda fade_out_values,y
sta temp_ptr
lda fade_out_values+1,y
sta temp_ptr+1
ldy #$00
jmp (temp_ptr)

fadeoutdone:
lda #$03
sta fadestate
jmp out

; PALS

fullpal:
lda #$00
sta tempa
lda #$1E
sta ppumask_soft
lda #$00
sta fadestate
jmp loop

fullpallow:
lda #$00
sta tempa
lda #$FE
sta ppumask_soft
jmp loop

paldim1low:
lda #$10
sta tempa
lda #$FE
sta ppumask_soft
jmp loop

paldim1:
lda #$10
sta tempa
lda #$1E
sta ppumask_soft
jmp loop

paldim2low:
lda #$20
sta tempa
lda #$FE
sta ppumask_soft
jmp loop

paldim2:
lda #$20
sta tempa
lda #$1E
sta ppumask_soft
jmp loop

paldim3low:
lda #$30
sta tempa
lda #$FE
sta ppumask_soft
jmp loop

paldim3:
lda #$30
sta tempa
lda #$1E
sta ppumask_soft
jmp loop

; copy the palette
loop:
lda (pal_ptr),y
sec
sbc tempa
bcs :+
lda #$0f
:
sta PALBUFFER,y
iny
cpy #$20
bne loop
rts
.endproc